#include <limits>

#include "common/time.h"
#include "random.h"

namespace sb7 {
	Random::Random()
			: randomGen(TRandomMersenne(get_time_ns() % 1000)) { }

	int Random::nextInt() {
		return randomGen.IRandom(0, std::numeric_limits<int>::max());
	}

	int Random::nextInt(int n) {
		return randomGen.IRandom(0, n - 1);
	}

	double Random::nextDouble() {
		return randomGen.Random();
	}
}

pthread_key_t sb7::random_key;

void sb7::global_init_random() {
	::pthread_key_create(&random_key, NULL);
}

void sb7::thread_init_random() {
	::pthread_setspecific(random_key,
		(const void *)(new sb7::Random()));
}
