#ifndef SB7_RANDOM_H_
#define SB7_RANDOM_H_

#include <pthread.h>

#include "stm.h"
#include "randomc/randomc.h"


namespace sb7 {
	class Random : public swisstm::SwisstmAlloced {
		public:
			Random();

			int nextInt();

			int nextInt(int n);

			double nextDouble();

		private:
			TRandomMersenne randomGen;
	};

	extern ::pthread_key_t random_key;

	// get thread local random object
	Random *get_random();

	void global_init_random();
	void thread_init_random();
}

inline sb7::Random *sb7::get_random() {
	return (sb7::Random *)::pthread_getspecific(random_key);
}

#endif /*SB7_RANDOM_H_*/
